/**
 * NativeEventEmitter 连接自己模块的通知
 *      new NativeEventEmitter(NativeModules.ToolsModule);
 * 
 * DeviceEventEmitter
 *      RN环境下注册接受通知
 * 
 * NativeAppEventEmitter
 *      警告⚠️ 毁弃API
 * 
 * 替代 DeviceEventEmitter
 */

import { EventType, EventTypeCenter } from "./EventType";

import { EventEmitterCenter } from "./EventEmitterCenter";
import { EventGroup } from "./EventGroup";

/**
    创建事件 
    let event = EventTypeCenter.registerEvent("ABCD");
    注册监听
    let aa = EventEmitterCenter.registerReceiver(event,({data})=>{
        
    })
    注册第二个监听
    let bb = EventEmitterCenter.registerReceiver(event,({data})=>{
        
    })

    //事件派发
    EventEmitterCenter.emit("ABCDQ",{a:1,b:2})

    //移除事件监听
    aa.unsubscribe();
 * 
 */

/**
 * 
       let cc =  EventEmitterCenter.registerReceivers(EventTypeCenter.registerEvents(["A","B"]),({type,data})=>{
           debugger
       })
       EventEmitterCenter.emit("A",[1,2,3])
       EventEmitterCenter.emit("B","AAAAAAAAAAA")
       cc.unsubscribe()
 */

const registerReceiver = function (event, handle) { return EventEmitterCenter.registerReceiver(event, handle) }
const registerReceivers = function (events, handle) { return EventEmitterCenter.registerReceivers(events, handle) }
const registerEvent = function (name) { return EventTypeCenter.registerEvent(name) }
const registerEvents = function (names) { return EventTypeCenter.registerEvents(names) }
export {
    EventType, EventTypeCenter, EventGroup, EventEmitterCenter,
    registerReceiver,
    registerReceivers,
    registerEvent,
    registerEvents
}