
import { SomeEventManager } from "./EVENTS";
//消息类型
export const MessageType = {
    //成功 不显示消息
    Success:0,
    //成功 显示消息
    SuccessShould:1000,
    //失败 不显示消息
    Fail:1,
    //失败 显示消息
    FailShould:1001,
    //错误 不显示消息
    Error:2,
    //错误 显示消息
    ErrorShould:1002,

    //大于这个值表示 消息必须显示
    MessageShould:999
}
//消息弹框状态
export const ModalStatus = {
    Hidden:1,
    Show:2
}
export class MessageBase{
    content = null;
    params = null
    constructor(content,params){
        this.content = content;
        this.params = params
    }
}
//消息体
export class Message extends MessageBase{
    type = MessageType.Success;
    duration = 750; //最短为750ms
    status = ModalStatus.Show;
    constructor(content,type,duration,status,params){
        super(content,params)
        this.content = content;
        this.type = type;
        this.duration = duration || 750;
        this.status = status || ModalStatus.Show;
        this.params = params
    }
}

class _MessageEventManager extends SomeEventManager{
    /**
     * 一个参数 
     * @param {*} message MessageBase
     */
    fireEvent(message){
        if(message instanceof MessageBase || message instanceof Message){
            return super.fireEvent(message)    
        }
        return super.fireEvent(new Message(message,MessageType.MessageShould))
    }
}

export default MessageManager = new _MessageEventManager("MessageEvent");

//Loading 状态
export const LoadingMessageManager = new SomeEventManager("LoadingMessageManager");

//权限状态弹出
export const PowerMessageManager = new SomeEventManager("PowerMessage");