/**
 * Created by tanlinwei
 *
 * Description:
 */

import {NetInfo} from 'react-native';

//检测网络状态的单列，在需要的地方初始化
export default class NetWorkManger {

    type = null;
    effectiveType = null;


    constructor() {
        this.instance = null;
    }


    static shared = () => {
        if (!this.instance) {
            this.instance = new NetWorkManger();
            NetInfo.addEventListener( //开启监听
                'connectionChange',
                this.instance.handleFirstConnectivityChange
            );
        }
        return this.instance;
    };

    //私有方法  不对外,当网络发生改变的时候就会发出监听
    handleFirstConnectivityChange = (connectionInfo) => {

        console.log("当前网络",connectionInfo);

        this.type = connectionInfo.type;
        this.effectiveType = connectionInfo.effectiveType;
    };

    //得到网络的有效类型 是1g、2g、3g、4g、unknown(这个应该是WiFi了)
    getConnectionEffectiveType = () => {
        return NetInfo.getConnectionInfo()
            .then((info) => {
                return info.effectiveType;
            });
    };


    //得到 网络类型 是wifi 还是cellular(蜂窝)
    getConnectionType = () => {
        NetInfo.getConnectionInfo()
            .then((info) => {
                return info.type;
            });
    };


    //判断是否有网络连接
    isInConnected = () => {
        return NetInfo.isConnected
            .fetch()
            .then(isConnected => {
                return isConnected;
            })
    }



}