import { Interceptor } from "./fetch";

class POSTBodyJSONInterceptor extends Interceptor {
    interceptor(request) {
        if (request.method == "POST") {
            request.option = {
                ...request.option,
                headers: {
                    ...request.option.headers,
                    Accept: 'application/json',
                    'Content-Type': 'application/json',
                },
                body: JSON.stringify(request.option.body)
            }
            return request;
        }
        return request;
    }
    clear() { }
}

class POSTFromDataInterceptor extends Interceptor {
    interceptor(request) {
        if (request.method == "POST") {
            newOptions = request.option;
            newOptions.headers = {
                ...newOptions.headers,
                'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8',
            };
            newOptions.mode = "cros";
            var formData = new FormData();
            for (var name in newOptions.body) {
                if (typeof newOptions.body[name] == "object") {
                    for (var o in newOptions.body[name]) {
                        formData.append(name + "[" + encodeURI(o) + "]", newOptions.body[name][o]);
                    }
                } else {
                    formData.append(name, newOptions.body[name]);
                }
            }
            newOptions.body = formData;
            request.option = newOptions;
            return request;
        }
        return request;
    }
}